<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class VI_WORDPRESS_LUCKY_WHEEL_DATA {
	private $params;
	private $default;
	protected static $instance = null;

	/**
	 * VI_WORDPRESS_LUCKY_WHEEL_DATA constructor.
	 * Init setting
	 */
	public function __construct() {
		global $wp_lucky_wheel_settings;
		if ( ! $wp_lucky_wheel_settings ) {
			$wp_lucky_wheel_settings = get_option( '_wplwl_settings', array() );
		}
		$this->default = array(
			'general'                           => array(
				'enable'     => "on",
				'mobile'     => "on",
				'spin_num'   => 1,
				'delay'      => 24,
				'delay_unit' => 'h'
			),
			'notify'                            => array(
				'position'                 => 'bottom-right',
				'size'                     => 40,
				'color'                    => '',
				'popup_icon'               => '',
				'popup_icon_color'         => '',
				'popup_icon_bg_color'      => '',
				'popup_icon_border_radius' => 0,
				'intent'                   => 'popup_icon',
				'hide_popup'               => 'off',
				'show_wheel'               => '1,5',//initial time
				'scroll_amount'            => '50',
				'show_again'               => 24,
				'show_again_unit'          => 'h',
				'show_only_front'          => 'off',
				'show_only_blog'           => 'off',
				'show_only_shop'           => 'off',
				'conditional_tags'         => '',
				'time_on_close'            => '1',
				'time_on_close_unit'       => 'd',
			),
			'wheel_wrap'                        => array(
				'description'            => '<h2><span style="color: #ffffff;">SPIN TO WIN!</span></h2>
<ul>
 	<li><em><span style="color: #dbdbdb;">Try your lucky to get discount coupon</span></em></li>
 	<li><em><span style="color: #dbdbdb;">1 spin per email</span></em></li>
 	<li><em><span style="color: #dbdbdb;">No cheating</span></em></li>
</ul>',
				'bg_image'               => VI_WORDPRESS_LUCKY_WHEEL_IMAGES . '2020.png',
				'bg_color'               => '#a77e44',
				'text_color'             => '#ffffff',
				'spin_button'            => 'Try Your Lucky',
				'spin_button_color'      => '#000000',
				'spin_button_bg_color'   => '#ffbe10',
				'pointer_position'       => 'center',
				'pointer_color'          => '#f70707',
				'wheel_center_image'     => '',
				'wheel_center_color'     => '#ffffff',
				'wheel_border_color'     => '#ffffff',
				'wheel_dot_color'        => '#000000',
				'close_option'           => 'on',
				'font'                   => '',
				'gdpr'                   => 'off',
				'gdpr_message'           => 'I agree with the <a href="">term and condition</a>',
				'custom_css'             => '',
				'congratulations_effect' => 'firework',
				'background_effect'      => 'snowflakes',
			),
			'wheel'                             => array(
				'spinning_time'     => 5,
				'wheel_speed'       => 3,
				'prize_type'        => array(
					"non",
					"custom",
					"non",
					"custom",
					"non",
					"custom",
					"non",
					"custom",
					"non",
					"custom",
					"non",
					"custom"
				),
				'custom_value'      => array(
					"",
					"prize",
					"",
					"prize",
					"",
					"prize",
					"",
					"prize",
					"",
					"prize",
					"",
					"prize"
				),
				'custom_label'      => array(
					"Not Lucky",
					"Prize",
					"Not Lucky",
					"Prize",
					"Not Lucky",
					"Prize",
					"Not Lucky",
					"Prize",
					"Not Lucky",
					"Prize",
					"Not Lucky",
					"Prize"
				),
				'prize_quantity'    => array( - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1 ),
				'probability'       => array( '10', '10', '10', '5', '10', '5', '10', '10', '10', '10', '5', '5' ),
				'bg_color'          => array(
					'#ffe0b2',
					'#e65100',
					'#ffb74d',
					'#fb8c00',
					'#ffe0b2',
					'#e65100',
					'#ffb74d',
					'#fb8c00',
					'#ffe0b2',
					'#e65100',
					'#ffb74d',
					'#fb8c00',
				),
				'slices_text_color' => array(
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
					'#fff',
				),
				'slice_text_color'  => '#fff',
				'show_full_wheel'   => 'off',
				'font_size'         => '100',
				'wheel_size'        => '100',
				'random_color'      => 'off',
				'quantity_label'    => '({prize_quantity} left)',
			),
			'result'                            => array(
				'auto_close'   => 0,
				'email'        => array(
					'from_name'             => '',
					'from_address'          => '',
					'subject'               => 'Wordpress lucky wheel award',
					'heading'               => 'Congratulations!',
					'content'               => "Dear {customer_name},\n You have won the {prize_label}. The code is {prize_value}. Please use this code and contact with us to receive the prize. Thank you.\n Your Sincerely!",
					'header_image'          => '',
					'footer_text'           => '',
					'base_color'            => '#a1fbf2',
					'background_color'      => '#5b9dd9',
					'body_background_color' => '#ffffff',
					'body_text_color'       => '#0f0f0f',
				),
				'notification' => array(
					'win'  => 'Congratulations! You have won a {prize_label}. Code was sent to {customer_email}. Please check your inbox. Thank you!',
					'lost' => 'Just almost win. Maybe you\'ll be lucky next time.',
				),
				'admin_email'  => array(
					'enable'  => 'off',
					'to'      => '',
					'subject' => 'Wordpress Lucky Wheel notification',
					'heading' => 'Wordpress Lucky Wheel',
					'content' => 'A customer with email {customer_email} has just won {prize_label}. Coupon code is : {prize_value}. Please moderate.'
				)
			),
			'mailchimp'                         => array(
				'enable'       => 'off',
				'double_optin' => 'off',
				'api_key'      => '',
				'lists'        => ''
			),
			'active_campaign'                   => array(
				'enable' => 'off',
				'key'    => '',
				'url'    => '',
				'list'   => '',
			),
			'key'                               => '',
			'button_shop_title'                 => 'Shop now',
			'button_shop_url'                   => get_bloginfo( 'url' ),
			'button_shop_color'                 => '#fff',
			'button_shop_bg_color'              => '#000',
			'button_shop_size'                  => '20',
			'sendgrid'                          => array(
				'enable' => 'off',
				'key'    => '',
				'list'   => 'none',
			),
			'ajax_endpoint'                     => 'ajax',
			'custom_field_email_enable'         => 'on',
			'custom_field_mobile_enable'        => 'off',
			'custom_field_mobile_enable_mobile' => 'off',
			'custom_field_mobile_required'      => 'off',
			'custom_field_name_enable'          => 'on',
			'custom_field_name_enable_mobile'   => 'on',
			'custom_field_name_required'        => 'off',
			'reset_spins_interval'              => 0,
			'reset_spins_hour'                  => 0,
			'reset_spins_minute'                => 0,
			'reset_spins_second'                => 0,
			'metrilo_enable'                    => '',
			'metrilo_token'                     => '',
			'metrilo_tag'                       => '',
			'metrilo_subscribed'                => '',
			'enable_hubspot'                    => '',
			'hubspot_api'                       => '',
			'enable_klaviyo'                    => '',
			'klaviyo_api'                       => '',
			'klaviyo_list'                      => '',
			'enable_sendinblue'                 => '',
			'sendinblue_api'                    => '',
			'sendinblue_list'                   => [],
			'enable_sendy'                      => '',
			'sendy_api'                         => '',
			'sendy_login_url'                   => '',
			'sendy_brand'                       => '',
			'sendy_list'                        => '',
			'enable_mailster'                   => '',
			'mailster_list'                     => [],
			'wplwl_recaptcha_site_key'          => '',
			'wplwl_recaptcha_version'           => '3',
			'wplwl_recaptcha_secret_theme'      => 'light',
			'wplwl_recaptcha_secret_key'        => '',
			'wplwl_recaptcha'                   => '',
		);

		$this->params = apply_filters( 'wp_lucky_wheel_params', wp_parse_args( $wp_lucky_wheel_settings, $this->default ) );
	}

	public static function get_instance( $new = false ) {
		if ( $new || null === self::$instance ) {
			self::$instance = new self;
		}

		return self::$instance;
	}

	public function get_params( $name = '', $name_sub = '', $language = '' ) {
		$language = apply_filters( '_wplwl_settings_language', $language, $name, $name_sub );
		if ( ! $name ) {
			return $this->params;
		} elseif ( isset( $this->params[ $name ] ) ) {
			if ( $name_sub ) {
				if ( isset( $this->params[ $name ][ $name_sub ] ) ) {
					if ( $language ) {
						$name_language = $name_sub . '_' . $language;
						if ( isset( $this->params[ $name ][ $name_language ] ) ) {
							return apply_filters( 'wp_lucky_wheel_params_' . $name . '__' . $name_language, $this->params[ $name ][ $name_language ] );
						} else {
							return apply_filters( 'wp_lucky_wheel_params_' . $name . '__' . $name_language, $this->params[ $name ][ $name_sub ] );
						}
					} else {
						return apply_filters( 'wp_lucky_wheel_params_' . $name . '__' . $name_sub, $this->params[ $name ] [ $name_sub ] );
					}
				} elseif ( $this->default[ $name ] [ $name_sub ] ) {
					return apply_filters( 'wp_lucky_wheel_params_' . $name . '__' . $name_sub, $this->default[ $name ] [ $name_sub ] );
				} else {
					return false;
				}
			} else {
				if ( $language ) {
					$name_language = $name . '_' . $language;
					if ( isset( $this->params[ $name_language ] ) ) {
						return apply_filters( 'wp_lucky_wheel_params_' . $name_language, $this->params[ $name_language ] );
					} else {
						return apply_filters( 'wp_lucky_wheel_params_' . $name_language, $this->params[ $name ] );
					}
				} else {
					return apply_filters( 'wp_lucky_wheel_params_' . $name, $this->params[ $name ] );
				}
			}
		} else {
			return false;
		}
	}

	public function get_default( $name = "", $name_sub = '' ) {
		if ( ! $name ) {
			return $this->default;
		} elseif ( isset( $this->default[ $name ] ) ) {
			if ( $name_sub ) {
				if ( isset( $this->default[ $name ][ $name_sub ] ) ) {
					return apply_filters( 'wp_lucky_wheel_params_default_' . $name . '__' . $name_sub, $this->default[ $name ] [ $name_sub ] );
				} else {
					return false;
				}
			} else {
				return apply_filters( 'wp_lucky_wheel_params_default_' . $name, $this->default[ $name ] );
			}
		} else {
			return false;
		}
	}

	/**
	 * @param $icon
	 *
	 * @return string
	 */
	public static function get_gift_icon_class( $icon ) {
		return "wplwl_gift_icons-{$icon}";
	}

	/**All icons from file ../css/giftbox.css
	 * Prefix wplwl_gift_icons-
	 * @return array
	 */
	public static function get_gift_icons() {
		return array(
			'aniversary-giftbox',
			'big-giftbox-and-gift-with-heart',
			'big-giftbox-with-bun',
			'big-giftbox-with-lateral-lace',
			'big-giftbox-with-ribbon',
			'cylindrical-giftbox-with-ribbon',
			'gifbox-with-lace',
			'gifbox-with-ribbon-in-the-middle',
			'gifbox-with-ribbon-on-top',
			'gifbox-wrapped-with-ribbon',
			'gift-with-bow',
			'gift-with-ribbon',
			'giftbox-side',
			'giftbox-with-a-big-ribbon-on-cover',
			'giftbox-with-a-heart',
			'giftbox-with-a-heart-on-side',
			'giftbox-with-big-lace',
			'giftbox-with-big-lace-1',
			'giftbox-with-big-ribbon',
			'giftbox-with-big-ribbon-1',
			'giftbox-with-big-ribbon-2',
			'giftbox-with-big-ribbon-3',
			'giftbox-with-bun',
			'giftbox-with-flower',
			'giftbox-with-hearts',
			'giftbox-with-lace-on-a-side',
			'giftbox-with-long-ribbon',
			'giftbox-with-ribbon',
			'giftbox-with-ribbon-on-one-side',
			'giftbox-with-ribbon-on-top',
			'giftbox-with-ribbon-on-top-1',
			'giftbox-wrapped',
			'heart-shape-giftbox-with-lace',
			'heart-shape-giftbox-with-ribbon',
			'heart-shapped-gifbox-with-ribbon',
			'open-box-with-two-hearts',
			'open-gitfbox-with-two-hearts',
			'polka-dots-giftbox-with-lace',
			'rectangular-giftbox-with-flower',
			'round-gift-box-with-lace',
			'round-giftbox-with-flower',
			'square-gifbox-wrapped',
			'square-gifsoft-with-bun',
			'square-giftbox-with-big-lace',
			'square-giftbox-with-big-ribbon',
			'three-giftboxes-with-ribbon-and-heart',
			'two-gifboxes-tied-together',
			'two-gifboxes-wrapped',
			'two-giftboxes',
			'valentines-giftbox'
		);
	}

	public static function get_all_bg_effects() {
		return array(
			'none'               => esc_html__( 'None', 'wordpress-lucky-wheel' ),
			'floating-halloween' => esc_html__( 'Halloween', 'wordpress-lucky-wheel' ),
			'halloween-1'        => esc_html__( 'Halloween 1', 'wordpress-lucky-wheel' ),
			'halloween-2'        => esc_html__( 'Halloween 2', 'wordpress-lucky-wheel' ),
			'halloween-3'        => esc_html__( 'Halloween 3', 'wordpress-lucky-wheel' ),
			'leaf-1'             => esc_html__( 'Falling Leaves 1', 'wordpress-lucky-wheel' ),
			'leaf-2'             => esc_html__( 'Falling Leaves 2', 'wordpress-lucky-wheel' ),
			'hearts'             => esc_html__( 'Hearts', 'wordpress-lucky-wheel' ),
			'heart'              => esc_html__( 'Heart', 'wordpress-lucky-wheel' ),
			'smile'              => esc_html__( 'Smile', 'wordpress-lucky-wheel' ),
			'star'               => esc_html__( 'Star', 'wordpress-lucky-wheel' ),
			'floating-bubbles'   => esc_html__( 'Balloons', 'wordpress-lucky-wheel' ),
			'snowflakes'         => esc_html__( 'Snowflake', 'wordpress-lucky-wheel' ),
			'snowflakes-1'       => esc_html__( 'Snowflake 1', 'wordpress-lucky-wheel' ),
			'snowflakes-2-2'     => esc_html__( 'Snowflake 2', 'wordpress-lucky-wheel' ),
			'snowflakes-2-1'     => esc_html__( 'Snowballs', 'wordpress-lucky-wheel' ),
			'snowflakes-2-3'     => esc_html__( 'Blurred snows', 'wordpress-lucky-wheel' ),
			'random'             => esc_html__( 'Random', 'wordpress-lucky-wheel' ),
		);
	}

	public static function wplwl_clean( $var ) {
		if ( is_array( $var ) ) {
			return array_map( [ __CLASS__, 'wplwl_clean' ], $var );
		} else {
			return is_scalar( $var ) ? sanitize_text_field( $var ) : $var;
		}
	}
}